(function(){"use strict";const DEBUG=('false'==='true');const EXTENSION_ID='fxtoolbar@click-sec.com';const URI_CONFIG='https://www.click-sec.com/data/fx/config/FXToolbar4Firefox/CLICKFX-toolbar.xml';const APPLI_VERSION='1.4.9';const RATE_UPDATE_INTERVAL=5;const CONFIG_UPDATE_INTERVAL=60;const CALENDAR_RANGE=86400;const CALENDAR_UPDATE_INTERVAL=60*60;const CHART_UPDATE_INTERVAL=60;const NEWS_WINDOW_NAME=EXTENSION_ID+'-NewsWindow';const RATECHARTQUEUE_SIZE=41;const MAX_RATEITEM_COUNT=6;const DOMAIN='extensions.fxtoolbar.';const TLD_LIST=['ccTLD_EU','ccTLD_CH','ccTLD_NZ','ccTLD_GB','ccTLD_CA','ccTLD_AU','ccTLD_DE','ccTLD_ZA','ccTLD_JP','ccTLD_US','ccTLD_CN','ccTLD_FR','ccTLD_HK','ccTLD_IN','ccTLD_TR'
];const CFD_TARGETS=['JP225','US30','DE30','GOLD','CL'
];const RATE_SPLITTER_FX=/^(.*)(\d\.?\d\.?\d)$/;const RATE_SPLITTER_CFD=RATE_SPLITTER_FX;const CALENDAR_BUTTON_FORMAT=/^\d+\/\d+\(.\)?/;var calendarData=[];var rateData=[];var newsData={};var rateChartQueue=new Array(RATECHARTQUEUE_SIZE);var stringBundle;var prefs;var mainTimer=null;var lastUpdateConfig=0;var lastUpdateCal=0;var lastUpdateRate=0;var lastUpdateRateChart=0;var lastUpdateNews=0;var alarmLastMin=0;var isLogin;var newsWindow;var isVersionCheck;var isServiceStatus;var Version;var VersionTime;var ServiceOpen;var ConfigInterval;var RateInterval;var RSSReadInterval;var FxRateURL;var CfdRateURL;var EcoCalURL;var FxNewsURL;var LoginPageURL_0;var DisclaimersURL;var AddonURL;var fileTimestamp;function $id(id){return document.getElementById(id)}
top.fxtoolbar={
load:function(){window.removeEventListener('load',fxtoolbar.load,false);stringBundle=$id("fxtoolbar-strings");prefs=Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch(DOMAIN);Components.classes['@mozilla.org/preferences;1'].getService(Components.interfaces.nsIPrefBranch2).addObserver(DOMAIN,fxtoolbar.prefListener,false);fxtoolbar.readConfigFile();fxtoolbar.onSecond();fxtoolbar.repaintAll();mainTimer=Components.classes["@mozilla.org/timer;1"].createInstance(Components.interfaces.nsITimer);mainTimer.init(fxtoolbar.timerListener,1000,Components.interfaces.nsITimer.TYPE_REPEATING_PRECISE)},versionCheck:function(){isVersionCheck=true;var nowDate=new Date();if(VersionTime<nowDate){window.openDialog("chrome://fxtoolbar/content/versioninfo.xul","","centerscreen,chrome,modal,resizable=no",AddonURL)}},
unload:function(){window.removeEventListener('unload',fxtoolbar.unload,false);Components.classes['@mozilla.org/preferences;1'].getService(Components.interfaces.nsIPrefBranch2).removeObserver(DOMAIN,fxtoolbar.prefListener,false);if(mainTimer){mainTimer.cancel();mainTimer=null}},prefListener:{observe:function(aSubject,aTopic,aPrefstring){if('nsPref:changed'==aTopic){fxtoolbar.repaintAll()}}},timerListener:{observe:function(aSubject,aTopic,aPrefstring){if('timer-callback'==aTopic){fxtoolbar.onSecond()}}},
readConfigFile:function(){fxtoolbar_helper.getUrl({url:URI_CONFIG,mime:"text/xml",ok:function(req){var fDate=new Date(req.getResponseHeader("last-modified"));if(fileTimestamp==null){fileTimestamp=fDate} else if(fileTimestamp.getTime()==fDate.getTime()){return} else {fileTimestamp=fDate}
var entries=req.responseXML.documentElement.querySelectorAll('version');var breakFlag=true;Array.forEach(entries,function(entry){Version=entry.getAttribute("major")+"."+entry.getAttribute("miner")+"."+entry.getAttribute("revision");if(breakFlag&&(APPLI_VERSION==Version||"9.9.9"==Version)){VersionTime=new Date(entry.getAttribute("time"));ServiceOpen=entry.getElementsByTagName("serviceOpen")[0].firstChild.nodeValue;RateInterval=entry.getElementsByTagName("rateInterval")[0].firstChild.nodeValue;RSSReadInterval=entry.getElementsByTagName("rSSReadInterval")[0].firstChild.nodeValue;ConfigInterval=entry.getElementsByTagName("configInterval")[0].firstChild.nodeValue;FxRateURL=entry.getElementsByTagName("fxRateURL")[0].firstChild.nodeValue;CfdRateURL=entry.getElementsByTagName("cfdRateURL")[0].firstChild.nodeValue;EcoCalURL=entry.getElementsByTagName("ecoCalURL")[0].firstChild.nodeValue;FxNewsURL=entry.getElementsByTagName("fxNewsURL")[0].firstChild.nodeValue;LoginPageURL_0=entry.getElementsByTagName("loginPageURL_0")[0].firstChild.nodeValue;DisclaimersURL=entry.getElementsByTagName("disclaimersURL")[0].firstChild.nodeValue;AddonURL=entry.getElementsByTagName("addonURL")[0].firstChild.nodeValue;breakFlag=false}})}})},
get ConfigUpdateInterval(){return DEBUG?10:ConfigInterval||CONFIG_UPDATE_INTERVAL},
get RateUpdateInterval(){return DEBUG?1:RateInterval||RATE_UPDATE_INTERVAL},
get ChartUpdateInterval(){return DEBUG?1:CHART_UPDATE_INTERVAL},
get CalendarUpdateInterval(){return DEBUG?60:CALENDAR_UPDATE_INTERVAL},
checkAlarm:function(){var enable=prefs.getBoolPref("enableSound");if(!enable||0===calendarData.length){return}
var current=Math.floor(new Date().getTime()/60000);if(current<=alarmLastMin){return}
alarmLastMin=current;fxtoolbar.repaintCal();fxtoolbar.setCalendarBackground(false);var agos=[];for(var data of calendarData){var time=(data.astTime)?Math.floor(data.astTime / 60000) : Math.floor(data.time / 60000);for(var i=1;i<=3;++i){var ago=agos[i]=agos[i]||(current+prefs.getIntPref('minutesAgo'+i));if(time==ago){fxtoolbar.playAlarm();fxtoolbar.setCalendarBackground(true);return}}}},
playAlarm:function(){try {var path=prefs.getCharPref("soundFilePath");if(!path){fxtoolbar_helper.play("chrome://fxtoolbar/skin/BellTransition.wav")} else {path="file:///"+path.replace(/\\/g, "/").replace(/\s/g,"%20");fxtoolbar_helper.play(path)}} catch(ex){}},
setCalendarBackground:function(fire){var ttCal=$id("fxtoolbar-calendar-button");if(fire){ttCal.setAttribute("alarmfire","true")} else {ttCal.removeAttribute("alarmfire")}},
onSecond:function(){var collapsed=$id("fxtoolbar").getAttribute("collapsed");if(ServiceOpen!='1'||collapsed=="true"){return}
if(!isVersionCheck){fxtoolbar.versionCheck()}
if(isServiceStatus){return}
var current=new Date().getTime();lastUpdateConfig=fxtoolbar_helper.ifrun(fxtoolbar.readConfigFile,current,fxtoolbar.ConfigUpdateInterval,lastUpdateConfig);lastUpdateCal=fxtoolbar_helper.ifrun(fxtoolbar.updateCal,current,fxtoolbar.CalendarUpdateInterval,lastUpdateCal);lastUpdateRate=fxtoolbar_helper.ifrun(fxtoolbar.updateRate,current,fxtoolbar.RateUpdateInterval,lastUpdateRate);lastUpdateNews=fxtoolbar_helper.ifrun(fxtoolbar.updateNews,current,RSSReadInterval,lastUpdateNews);fxtoolbar.checkAlarm()},
openSetting:function(){window.openDialog("chrome://fxtoolbar/content/options.xul","","centerscreen,chrome,modal,resizable=no")},
openVersion:function(){window.openDialog("chrome://fxtoolbar/content/version.xul","","centerscreen,chrome,modal,resizable=no")},
openAddonsMgr:function(){window.BrowserOpenAddonsMgr("addons://detail/"+encodeURIComponent(EXTENSION_ID))},
repaintAll:function(){var toolbar=$id("fxtoolbar");toolbar.setAttribute("useflag",prefs.getBoolPref("useFlag"));toolbar.setAttribute("showcal",prefs.getBoolPref("showCal"));toolbar.setAttribute("shownews",prefs.getBoolPref("showNews"));fxtoolbar.repaintCal();fxtoolbar.repaintRates();fxtoolbar.repaintNews()},
updateCal:function(){var nowTime=new Date(new Date().setSeconds(0));fxtoolbar_helper.getUrl({url:EcoCalURL+'cal_'+fxtoolbar_helper.formatDate(nowTime,'yyyy_MM')+'.csv',mime:"text/plain; charset=shift_jis",ok:function(req){var nowCalendarData=fxtoolbar.convertCalendarData(req,nowTime);var nextTime=new Date(new Date().setSeconds(0));nextTime=nextTime.setMonth(nextTime.getMonth()+1);fxtoolbar_helper.getUrl({url:EcoCalURL+'cal_'+fxtoolbar_helper.formatDate(nextTime,'yyyy_MM')+'.csv',mime:"text/plain; charset=shift_jis",ready:function(req){if(404==req.status){calendarData=nowCalendarData;fxtoolbar.repaintCal()}},ok:function(req){var nextCalendarData=fxtoolbar.convertCalendarData(req,nowTime);calendarData=nowCalendarData.concat(nextCalendarData);fxtoolbar.repaintCal()}})}})},
analysisAsterData:function(listAAA,newLines,line_yyyymmdd){var asterFlg=new Boolean(false);var dateFlg=new Boolean(false);for(var jj=0;jj<listAAA.length;jj++){var nLine=listAAA[jj].split(",",3);if('***'!=nLine[1]){dateFlg=true;break}}
var topLine=listAAA[0].split(",",3);if('***'==topLine[1]){asterFlg=true}
if(asterFlg==false){var endLine=listAAA[listAAA.length-1].split(",");if('***'==endLine[1]){asterFlg=true}}
if(asterFlg==true&&dateFlg==false){for(var jj=0;jj<listAAA.length;jj++){var nLine=listAAA[jj].split(",",3);var strs=[line_yyyymmdd,"0:00",nLine[2],"1"];newLines.push(strs.join(","))}} else if(asterFlg==true&&dateFlg==true){var cangeFlg=new Boolean(false);for(var jj=0;jj<listAAA.length;jj++){var nLine=listAAA[jj].split(",",3);if('***'==nLine[1]){if(cangeFlg==true){var strs=[line_yyyymmdd,"23:59",nLine[2],"1"];newLines.push(strs.join(","))} else {var strs=[line_yyyymmdd,"0:00",nLine[2],"1"];newLines.push(strs.join(","))}} else {cangeFlg=true;var strs=[line_yyyymmdd,nLine[1],nLine[2],"0"];newLines.push(strs.join(","))}}} else {for(var jj=0;jj<listAAA.length;jj++){var nLine=listAAA[jj].split(",",3);var strs=[line_yyyymmdd,nLine[1],nLine[2],"0"];newLines.push(strs.join(","))}}
return newLines},
convertCalendarData:function(req,nowTime){var lines=req.responseText.split("\n");var line_yyyymmdd;var line_hhmm;var line_date;var items=[];var endTime=(CALENDAR_RANGE+fxtoolbar.CalendarUpdateInterval)*1000;var weekTable=new Array(stringBundle.getString('calendar.week_sunday'),stringBundle.getString('calendar.week_monday'),stringBundle.getString('calendar.week_tuesday'),stringBundle.getString('calendar.week_wednesday'),stringBundle.getString('calendar.week_thursday'),stringBundle.getString('calendar.week_friday'),stringBundle.getString('calendar.week_saturday'));var newLines=[];var listAAA=[];for(var ii=0;ii<lines.length;ii++){var line=lines[ii].split(",");if(ii==0){line_yyyymmdd=line[0]}
if(ii!=0&&line[0]&&listAAA.length!=0){var beforeDate=new Date(line[0]);beforeDate.setDate(beforeDate.getDate()-1);line_yyyymmdd=fxtoolbar_helper.formatDate(beforeDate,'yyyy/MM/dd');fxtoolbar.analysisAsterData(listAAA,newLines,line_yyyymmdd);listAAA=[];line_yyyymmdd=line[0]}
if(line[1]){listAAA.push(lines[ii])}}
if(listAAA.length!=0){fxtoolbar.analysisAsterData(listAAA,newLines,line_yyyymmdd)}
for(var ii=0;ii<newLines.length;ii++){var line=newLines[ii].split(",");line_date=new Date(line[0]);var line_time=new Date(line[0]+" "+line[1]);if(endTime<line_time-nowTime){break}
if(nowTime<=line_time){var line_text=line[2];line_text=line_text.replace(/(\r\n|\n|\r)/g,"");items.push({time:((1==line[3])?'***':line_time),date:line_date,text:(line_date.getMonth()+1)+"/"+line_date.getDate()+"("+weekTable[line_date.getDay()]+") "+(('1'==line[3])?'***':line[1])+" "+line_text,searchText:fxtoolbar.removeCountryText(line_text),tld:fxtoolbar.getCalendarTLD(line_text),astTime:((1==line[3])?line_time:'') })}}
return items},
repaintCal:function(){var menupopup=$id("fxtoolbar-calendar-popup");var separator=$id("fxtoolbar-calendar-command-separator");while(menupopup.hasChildNodes()&&menupopup.firstChild!=separator){menupopup.removeChild(menupopup.firstChild)}
var firstItem;function addItem(attr,before){firstItem=firstItem||attr;var item=document.createElement("menuitem");for(var name in attr){item.setAttribute(name,attr[name])}
menupopup.insertBefore(item,before||separator)}
var now=new Date();var endTime=now.getTime()+CALENDAR_RANGE*1000;var lastDate=new Date(now.getFullYear(),now.getMonth(),now.getDate());for(var data of calendarData){if(data.time<now){continue}
if(endTime<data.time){break}
if(lastDate<data.date){menupopup.insertBefore(document.createElement("menuseparator"),separator);lastDate=data.date}
try {if(data.tld==""){addItem({label:data.text,searchtext:data.searchText,oncommand:"fxtoolbar.searchText(event)"
})}
else {addItem({label:data.text,"class":"calMenuItem menuitem-iconic",properties:data.tld,searchtext:data.searchText,oncommand:"fxtoolbar.searchText(event)"
})}} catch(ex){}}
if("menuseparator"==menupopup.firstChild.nodeName){addItem({label:stringBundle.getString("calendar.noData") },menupopup.firstChild)}
var ttCal=$id("fxtoolbar-calendar-button");var label=firstItem.label.replace(CALENDAR_BUTTON_FORMAT,'');ttCal.setAttribute("label",label);if(firstItem.properties){ttCal.setAttribute("properties",firstItem.properties)} else {ttCal.removeAttribute("properties")}},searchText:function(event){var text=event.target.getAttribute("searchtext");var url="http://www.google.co.jp/search?q=\""+encodeURIComponent(text)+"\"";var target=event.ctrlKey?"current":"tab";window.openUILinkIn(url,target)},openCalendarList:function(event){var nowDate=new Date();var url="https://www.click-sec.com/corp/guide/fx/cal/"+fxtoolbar_helper.formatDate(nowDate,'yyyyMM')+'.html#D'+fxtoolbar_helper.formatDate(nowDate,'yyyyMMdd');var target=event.ctrlKey?"current":"tab";window.openUILinkIn(url,target)},getCalendarTLD:function(text){var result="";for(var tld of TLD_LIST){if(-1!=text.indexOf(stringBundle.getString("calendar."+tld))){if(result){return ""}
result=tld}}
return result},removeCountryText:function(text){for(var tld of TLD_LIST){text=text.replace(stringBundle.getString("calendar."+tld),"")}
return text},
updateRate:function(){var fxRateData=null;var cfdRateData=null;load({url:FxRateURL,mime:"text/plain; charset=shift_jis",parse:function(text){fxRateData=fxtoolbar.parseFxRateData(text)}});load({url:CfdRateURL,mime:"text/plain; charset=shift_jis",parse:function(text){cfdRateData=fxtoolbar.parseCfdRateData(text)}});function load(opt){opt.ok=function(req){var text=req.responseText;if(text){opt.parse(text);updated()}};fxtoolbar_helper.getUrl(opt)}
function updated(){if(!fxRateData||!cfdRateData) return;rateData=fxtoolbar.concatRateData(fxRateData,cfdRateData);lastUpdateRateChart=fxtoolbar_helper.ifrun(fxtoolbar.updateRateChart,new Date().getTime(),fxtoolbar.ChartUpdateInterval,lastUpdateRateChart);fxtoolbar.repaintRates(true)}},
parseFxRateData:function(text){var rates=[];var lines=text.split('\n').length;text.split("\n",lines).forEach(function(line){if(line){var col=line.split('\t');rates.push({splitter:RATE_SPLITTER_FX,id:col[0],name:col[0].replace(/(?=...$)/, '/'),
					bid:  col[1],
					ask:  col[2],
					high: col[5],
					low:  col[6]
				});
			}
		});
		return rates;
	},
	
	parseCfdRateData : function(text) {
		var rates = [];
		var hash = {};
		text.split("\n").forEach(function(line) {
			if (line) {
				var col = line.split(',');
				hash[col[0]] = {
					splitter: RATE_SPLITTER_CFD,
					name: col[0],
					bid:  col[1],
					ask:  col[2],
					high: col[4],
					low:  col[5]
				};
			}
		});
				CFD_TARGETS.forEach(function(cfd_id) {
			var cfd_name = stringBundle.getString("rate.cfd_" + cfd_id);
			var rate = hash[cfd_name];
			if (rate) {
				rate.id = cfd_id;
				rates.push(rate);
			}
		});
		return rates;
	},
	
	concatRateData : function(fxRateData, cfdRateData) {
		var rates = [];
		rates.push({
			isSeparator: true,
			label: stringBundle.getString("rate.separator_fx") });
		rates = rates.concat(fxRateData);
		rates.push({
			isSeparator: true,
			label: stringBundle.getString("rate.separator_cfd") });
		rates = rates.concat(cfdRateData);
		return rates;
	},
	
	repaintRates : function(withChart) {
		var rateCount = prefs.getIntPref("countRate");
		for (var i = 0; i < MAX_RATEITEM_COUNT; ++i) {
			var rateitem = $id('fxtoolbar-rateitem' + i);
			if (rateitem) {
				rateitem.style.display = (i < rateCount) ? '' : 'none';
				rateitem.rateData = rateData;
				if (withChart) {
					rateitem.rateChartQueue = rateChartQueue;
				}
			}
		}
	},
	
	updateRateChart : function() {
				if (RATECHARTQUEUE_SIZE <= rateChartQueue.length) {
			rateChartQueue.splice(0, 1 + rateChartQueue.length - RATECHARTQUEUE_SIZE);
		}
				var time = new Date();
		var lastTime = (rateChartQueue[rateChartQueue.length - 1] || {}).time;
		var limit = new Date(time - fxtoolbar.ChartUpdateInterval * 2 * 1000);
		if (lastTime && lastTime < limit) {
			rateChartQueue = new Array(RATECHARTQUEUE_SIZE - 1);
		}
				rateChartQueue.push({
			time: time,
			timeString: fxtoolbar_helper.formatDate(time, 'HH:mm'),
			rateData: rateData
		});
	},
	
	clickNews : function(event) {
		if(event.type!="click" || event.target.nodeName!="toolbarbutton") {
			return;
		}
		if(isLogin) {
			if (newsWindow && !newsWindow.closed) {
				newsWindow.close();
				newsWindow = null;
			} else {
				fxtoolbar.openNewsWindow();
			}
		} else {
			window.openUILink(LoginPageURL_0, event, false, true);
		}
	},
	getNewsWindow : function() {
		return Components.classes["@mozilla.org/embedcomp/window-watcher;1"]
			.getService(Components.interfaces.nsIWindowWatcher)
			.getWindowByName(NEWS_WINDOW_NAME, null);
	},
	openNewsWindow : function() {
		newsWindow = fxtoolbar.getNewsWindow();
		if (!newsWindow) {
			newsWindow = window.openDialog(
					"chrome://fxtoolbar/content/news.xul",
					NEWS_WINDOW_NAME,
					"chrome,modal=no,dependent=yes,resizable=yes",
					DisclaimersURL, newsData);
		}
		newsWindow.addEventListener('close', function close() {
				newsWindow.removeEventListener('close', close, false);
				newsWindow = null;
			}, false);
		newsWindow.focus();
	},
	
	updateNews : function() {
		fxtoolbar_helper.getUrl({
			url: FxNewsURL,
			mime: "text/xml",
			ok: function(req) {
				var doc = req.responseXML.documentElement;
				function findNode(query, node){
					return (node || doc).querySelectorAll(query);
				}
				function getValue(node, query) {
					return findNode(query, node)[0].textContent;
				}
								var items = findNode('item');
				if (items.length === 0) {
					newsData = {};
					isLogin = false;
				} else {
					isLogin = true;
				}
								var last = new Date(getValue(doc, 'lastBuildDate'));
				if (isNaN(last) || newsData.lastBuildDate && last <= newsData.lastBuildDate) {
					return;
				}
				newsData.lastBuildDate = last;
				newsData.items = Array.map(items, function(item) {
					var authorId = fxtoolbar_helper.stripTag(getValue(item, 'author'));
					var pubDateObj = new Date(fxtoolbar_helper.stripTag(getValue(item, 'pubDate')));
					return {
						title				: fxtoolbar_helper.stripTag(getValue(item, 'title')),
						description : fxtoolbar_helper.stripTagWithoutBr(getValue(item, 'description')),
						authorId		: authorId,
						author			: stringBundle.getString("news.author." + authorId),
						pubDateObj	: pubDateObj,
						pubDate			: fxtoolbar_helper.formatDate(pubDateObj)
					};
				});
				fxtoolbar.repaintNews();
			}
		});
	},
	
	repaintNews : function() {
		var ttNews = $id("fxtoolbar-news-button");
				if(isLogin) {
			var label = "-";
			if ("items" in newsData && 0 < newsData.items.length) {
				label = newsData.items[0].title;
			}
			ttNews.setAttribute("label", label);
			ttNews.setAttribute("tooltiptext", stringBundle.getString("news.loggedon.tooltip"));
						if (newsWindow && !newsWindow.closed) {
				newsWindow.news.repaintNews();
			}
		} else {
			ttNews.setAttribute("label", stringBundle.getString("news.loggedoff"));
			ttNews.setAttribute("tooltiptext", stringBundle.getString("news.loggedoff.tooltip"));
						if (newsWindow && !newsWindow.closed) {
				newsWindow.close();
			}
			newsWindow = null;
		}
	}};
window.addEventListener('load', fxtoolbar.load, false);
window.addEventListener('unload', fxtoolbar.unload, false);
})();